## lomiri-thumbnailer 3.0.5

=== CMakeLists.txt ===
# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
    set(LOCAL_INSTALL "ON")
endif()

cmake_minimum_required(VERSION 3.10)
project(lomiri-thumbnailer VERSION "3.0.5" LANGUAGES C CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)



string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lower case

set(ACCEPTED_BUILD_TYPES "" none release debug relwithdebinfo coverage)
list(FIND ACCEPTED_BUILD_TYPES "${cmake_build_type_lower}" IS_BUILD_TYPE_ACCEPTED)
if (${IS_BUILD_TYPE_ACCEPTED} EQUAL -1)
    message(FATAL_ERROR "Invalid CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}\nValid types are: ${ACCEPTED_BUILD_TYPES}")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++17 -Wall -pedantic -Wextra -fvisibility=hidden")

# Some additional warnings not included by the general flags set above.
set(EXTRA_C_WARNINGS "-Wcast-align -Wcast-qual -Wformat -Wredundant-decls -Wswitch-default")
set(EXTRA_CXX_WARNINGS "-Wnon-virtual-dtor -Wctor-dtor-privacy -Wold-style-cast")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_C_WARNINGS} ${EXTRA_CXX_WARNINGS}")

# By default, for release builds, warnings become hard errors.
if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

# If warnings are errors, don't error on deprecated declarations.
if (${Werror})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
    if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=deprecated-declarations")
    endif()
endif()

add_definitions(-DQT_NO_KEYWORDS)

include(GNUInstallDirs)

# liblomiri-thumbnailer-qt version
set(LIBTHUMBNAILER_QT lomiri-thumbnailer-qt)
set(LIBTHUMBNAILER_QT_SO_VERSION_MAJOR "1")
set(LIBTHUMBNAILER_QT_SO_VERSION_MINOR "0")
set(LIBTHUMBNAILER_QT_SO_VERSION_MICRO "0")
set(LIBTHUMBNAILER_QT_SO_VERSION ${LIBTHUMBNAILER_QT_SO_VERSION_MAJOR}.${LIBTHUMBNAILER_QT_SO_VERSION_MINOR})
set(LIBTHUMBNAILER_QT_HDR_INSTALL_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${LIBTHUMBNAILER_QT}-${LIBTHUMBNAILER_QT_SO_VERSION})

# Encoding version of cache files
set(THUMBNAILER_CACHE_VERSION "2")

# Flags for thread/address sanitizer
set(SANITIZER "" CACHE STRING "Build with -fsanitize=<value> (legal values: thread, address)")

if ("${SANITIZER}" STREQUAL "")
    # Do nothing
elseif (${SANITIZER} STREQUAL "thread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer -g")
elseif (${SANITIZER} STREQUAL "address")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -g")
else()
    message(FATAL_ERROR "Invalid SANITIZER setting: ${SANITIZER}")
endif()

# Some tests are slow, so make it possible not to run them
# during day-to-day development.
option(slowtests "Run slow tests" ON)
if (${slowtests})
    add_definitions(-DSLOW_TESTS=1)
else()
    add_definitions(-DSLOW_TESTS=0)
endif()

# TODO: Hack to allow disabling tests that need QDBus on xenial and yakkety,
#       due to broken Qt 5.6. Re-enable tests ASAP!
option(skip-dbus-tests "Skip DBus tests" ON)
if (${skip-dbus-tests})
    execute_process(COMMAND lsb_release -s -c OUTPUT_VARIABLE distro OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND uname -m OUTPUT_VARIABLE arch OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (
            (${distro} STREQUAL "xenial" OR ${distro} STREQUAL "yakkety" OR ${distro} STREQUAL "zesty")
            AND
            (${arch} STREQUAL "aarch64" OR ${arch} STREQUAL "ppc" OR ${arch} STREQUAL "ppc64le")
       )
        message(WARNING "WARNING: Disabling DBus-related tests for ${distro}
         See https://bugs.launchpad.net/ubuntu/+source/thumbnailer/+bug/1613561
             https://bugs.launchpad.net/ubuntu/+source/qtbase-opensource-src/+bug/1625930")
        add_definitions(-DSKIP_DBUS_TESTS=1)
        add_definitions(-DDISTRO=\"${distro}\")
        add_definitions(-DARCH=\"${arch}\")
    endif()
endif()

option(ENABLE_UBUNTU_COMPAT "Enable Ubuntu.Thumbnailer QML compatibility type" OFF)

# Workaround static-TLS space exhaustion that happens due to some version of GlibC trying
# to optimize TLS access for dynamically-loaded (dlopen()'ed) libraries on some arch,
# but end up not having enough static-TLS area for the library that need it.
# For us, it happens with libgomp.so.1 loaded via libgstlibav.so plugin, inside vs-thumb.
# The workaround is to LD_PRELOAD libgomp.so.1, so that it has static TLS slots it needs.
#
# https://bugzilla.redhat.com/show_bug.cgi?id=1722181
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=964141
# https://sourceware.org/bugzilla/show_bug.cgi?id=25051
option(WORKAROUND_LIBGOMP_STATIC_TLS "Workaround libgomp.so.1 static TLS problem" OFF)
if (${WORKAROUND_LIBGOMP_STATIC_TLS})
    add_definitions(-DWORKAROUND_LIBGOMP_STATIC_TLS)
endif()

# Definitions for testing with valgrind.

configure_file(CTestCustom.cmake.in CTestCustom.cmake) # Tests in CTestCustom.cmake are skipped for valgrind

find_program(MEMORYCHECK_COMMAND NAMES valgrind)
if (MEMORYCHECK_COMMAND)
    set(MEMORYCHECK_COMMAND_OPTIONS
        "--suppressions=${CMAKE_SOURCE_DIR}/valgrind-suppress --errors-for-leak-kinds=definite --show-leak-kinds=definite --leak-check=full --num-callers=50 --error-exitcode=3"
    )
    add_custom_target(valgrind DEPENDS NightlyMemCheck)
else()
    message(WARNING "Cannot find valgrind: valgrind target will not be available")
endif()

include(CTest)

if (cmake_build_type_lower MATCHES coverage)
    find_package(CoverageReport REQUIRED)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -coverage" )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -coverage" )
endif()


include(cmake/UseGSettings.cmake)

set(SHARE_PRIV_DIR ${CMAKE_INSTALL_LIBEXECDIR}/lomiri-thumbnailer)
set(SHARE_PRIV_ABS ${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-thumbnailer)

find_package(Boost COMPONENTS filesystem iostreams regex system REQUIRED)
find_package(Threads REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)

include(FindPkgConfig)
pkg_check_modules(GST_DEPS REQUIRED gstreamer-1.0 gstreamer-plugins-base-1.0 gstreamer-tag-1.0)
pkg_check_modules(GOBJ_DEPS REQUIRED gobject-2.0)
pkg_check_modules(GIO_DEPS REQUIRED gio-2.0 gio-unix-2.0)
pkg_check_modules(IMG_DEPS REQUIRED gdk-pixbuf-2.0 libexif)
pkg_check_modules(LOMIRI_API_DEPS REQUIRED liblomiri-api)
pkg_check_modules(APPARMOR_DEPS REQUIRED libapparmor)
pkg_check_modules(TAGLIB_DEPS REQUIRED taglib)
pkg_check_modules(CACHE_DEPS REQUIRED libpersistent-cache-cpp)

include_directories(${GST_DEPS_INCLUDE_DIRS})
include_directories(${GOBJ_DEPS_INCLUDE_DIRS})
include_directories(${GIO_DEPS_INCLUDE_DIRS})
include_directories(${IMG_DEPS_INCLUDE_DIRS})
include_directories(${LOMIRI_API_DEPS_INCLUDE_DIRS})
include_directories(${APPARMOR_DEPS_INCLUDE_DIRS})
include_directories(${TAGLIB_DEPS_INCLUDE_DIRS})
include_directories(include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)

set(UNIT_TEST_TARGETS "")

add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(plugins/Lomiri/Thumbnailer.0.1)
if (${ENABLE_UBUNTU_COMPAT})
    add_subdirectory(plugins/Ubuntu/Thumbnailer.0.1)
endif()
if (${BUILD_TESTING})
    find_package(Qt5Test REQUIRED)
    find_package(Qt5QuickTest REQUIRED)
    find_package(Qt5Network REQUIRED)

    find_package(GMock REQUIRED)

    add_subdirectory(tests)
endif()
add_subdirectory(include)
add_subdirectory(man)

option(ENABLE_DOC "Build documentation" ON)
if(ENABLE_DOC)
    add_subdirectory(doc)
endif()

if (cmake_build_type_lower MATCHES coverage)
    enable_coverage_report(
        TARGETS
            recovery_test         # Need to turn on coverage for this, to get the helper template instrumented.
            testutils
            test-seq
            lomiri-thumbnailer-admin
            LomiriThumbnailer-qml
            thumbnailer-qml-static
            lomiri-thumbnailer-qt
            thumbnailer-service
            thumbnailer-static
            vs-thumb
            vs-thumb-static
        FILTER
            ${CMAKE_SOURCE_DIR}/tests/*
            ${CMAKE_BINARY_DIR}/*
        TESTS
            ${UNIT_TEST_TARGETS}
    )
endif()

=== data/CMakeLists.txt ===
add_schema(com.lomiri.Thumbnailer.gschema.xml)

# compile schema - only needed for tests; actual schema is handled as part of add_schema above
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} gio-2.0 --variable glib_compile_schemas OUTPUT_VARIABLE _glib_comple_schemas OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process (COMMAND ${_glib_comple_schemas} ${CMAKE_CURRENT_SOURCE_DIR} --targetdir=${CMAKE_CURRENT_BINARY_DIR} OUTPUT_STRIP_TRAILING_WHITESPACE)

configure_file(
  etc_apport_blacklist.d_lomiri-thumbnailer.in
  etc_apport_blacklist.d_lomiri-thumbnailer
  @ONLY
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/etc_apport_blacklist.d_lomiri-thumbnailer"
  RENAME lomiri-thumbnailer
  DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}/apport/blacklist.d"
)

=== doc/CMakeLists.txt ===
add_subdirectory(liblomiri-thumbnailer-qt)

if(BUILD_TESTING)
    list(APPEND UNIT_TEST_TARGETS qt_example_test)
    set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)
endif()

=== include/CMakeLists.txt ===
add_subdirectory(internal)
add_subdirectory(lomiri)

=== man/CMakeLists.txt ===
set(section1
    lomiri-thumbnailer-admin.1
    thumbnailer-service.1
)

set(section5
    thumbnailer-settings.5
)

install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/${section1}
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
)

install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/${section5}
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man5
)

=== src/CMakeLists.txt ===
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/settings-defaults.h
    COMMAND ${CMAKE_SOURCE_DIR}/tools/parse-settings.py
        -i ${CMAKE_SOURCE_DIR}/data/com.lomiri.Thumbnailer.gschema.xml
        -o ${CMAKE_CURRENT_BINARY_DIR}/settings-defaults.h
    DEPENDS ${CMAKE_SOURCE_DIR}/data/com.lomiri.Thumbnailer.gschema.xml)

add_custom_target(generate-settings-defaults
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/settings-defaults.h)

set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/settings-defaults.h
    PROPERTIES GENERATED TRUE HEADER_FILE_ONLY TRUE)

set_source_files_properties(settings.cpp PROPERTIES
    OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/settings-defaults.h)

add_library(thumbnailer-static STATIC
    artdownloader.cpp
    backoff_adjuster.cpp
    check_access.cpp
    file_io.cpp
    file_lock.cpp
    image.cpp
    imageextractor.cpp
    local_album_art.cpp
    make_directories.cpp
    mimetype.cpp
    ratelimiter.cpp
    safe_strerror.cpp
    settings.cpp
    trace.cpp
    thumbnailer.cpp
    ubuntuserverdownloader.cpp
    version.cpp
    ${CMAKE_SOURCE_DIR}/include/internal/artdownloader.h
    ${CMAKE_SOURCE_DIR}/include/internal/artreply.h
    ${CMAKE_SOURCE_DIR}/include/internal/imageextractor.h
    ${CMAKE_SOURCE_DIR}/include/internal/thumbnailer.h
    ${CMAKE_SOURCE_DIR}/include/internal/ubuntuserverdownloader.h
)

set_target_properties(thumbnailer-static PROPERTIES AUTOMOC TRUE)

target_link_libraries(thumbnailer-static
    Qt5::Core
    Qt5::Network
    ${Boost_LIBRARIES}
    ${GLIB_DEPS_LDFLAGS}
    ${GIO_DEPS_LDFLAGS}
    ${IMG_DEPS_LDFLAGS}
    ${LOMIRI_API_DEPS_LDFLAGS}
    ${APPARMOR_DEPS_LDFLAGS}
    ${TAGLIB_DEPS_LDFLAGS}
    ${CACHE_DEPS_LDFLAGS}
)

add_subdirectory(liblomiri-thumbnailer-qt)
add_subdirectory(service)
add_subdirectory(thumbnailer-admin)
add_subdirectory(vs-thumb)

=== tests/CMakeLists.txt ===
# We add -g so we get debug info for the gtest stack frames with gdb.
# The warnings are suppressed so we get a noise-free build for gtest and gmock.

set(old_cxx_flags ${CMAKE_CXX_FLAGS})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wno-old-style-cast -Wno-missing-field-initializers")
set(CMAKE_CXX_FLAGS ${old_cxx_flags})

set(TESTDATADIR ${CMAKE_CURRENT_SOURCE_DIR}/media)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

configure_file(testsetup.h.in testsetup.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(utils)

set(unit_test_dirs
    art_extractor
    check_access
    dbus
    download
    file_io
    gobj_ptr
    image
    image-provider
    qml
    liblomiri-thumbnailer-qt
    recovery
    safe_strerror
    settings
    thumbnailer
    thumbnailer-admin
    version
    vs-thumb
)

set(slow_test_dirs
    backoff_adjuster
    file_lock
    slow-vs-thumb
    stress
)

foreach(dir ${unit_test_dirs})
    add_subdirectory(${dir})
    list(APPEND UNIT_TEST_TARGETS "${dir}_test")
endforeach()

if (${slowtests})
    foreach(dir ${slow_test_dirs})
        add_subdirectory(${dir})
        list(APPEND UNIT_TEST_TARGETS "${dir}_test")
    endforeach()
    add_subdirectory(headers)
endif()

set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)

if (${slowtests})
    add_subdirectory(copyright)
endif()
add_subdirectory(whitespace)

=== doc/liblomiri-thumbnailer-qt/CMakeLists.txt ===
find_package(DoxygenBuilder REQUIRED)

file(GLOB libthumbnailer_headers "${PROJECT_SOURCE_DIR}/include/lomiri/thumbnailer/qt/*.h")

add_doxygen(
    liblomiri-thumbnailer-qt-doc
    PROJECT_NAME
        "Thumbnailer Qt API"
    INPUT
        ${CMAKE_CURRENT_SOURCE_DIR}/tutorial.dox
        ${libthumbnailer_headers}
    EXAMPLE_PATH
        ${CMAKE_CURRENT_SOURCE_DIR}
    STRIP_FROM_PATH
        "${CMAKE_SOURCE_DIR}/src"
    STRIP_FROM_INC_PATH
        "${CMAKE_SOURCE_DIR}/include"
    DOXYFILE_IN
        ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    EXCLUDE_PATTERNS
        */internal/*
    EXCLUDE_SYMBOLS
        *::internal*
        *::Priv
    INSTALL
        ${CMAKE_INSTALL_DOCDIR}
    ALL
)

if(BUILD_TESTING)
    add_subdirectory(examples)

    list(APPEND UNIT_TEST_TARGETS qt_example_test)
    set(UNIT_TEST_TARGETS ${UNIT_TEST_TARGETS} PARENT_SCOPE)
endif()

=== include/lomiri/CMakeLists.txt ===
add_subdirectory(thumbnailer)

=== src/liblomiri-thumbnailer-qt/CMakeLists.txt ===
set(dbusinterface_xml "${CMAKE_SOURCE_DIR}/src/service/dbusinterface.xml")
set_source_files_properties(${dbusinterface_xml} PROPERTIES
  CLASSNAME ThumbnailerInterface
  INCLUDE ${CMAKE_SOURCE_DIR}/include/service/client_config.h)
qt5_add_dbus_interface(interface_files ${dbusinterface_xml} thumbnailerinterface)

add_library(${LIBTHUMBNAILER_QT} SHARED
  liblomiri-thumbnailer-qt.cpp
  ${CMAKE_SOURCE_DIR}/src/service/client_config.cpp
  ${CMAKE_SOURCE_DIR}/include/lomiri/thumbnailer/qt/lomiri-thumbnailer-qt.h
  ${interface_files}
)

include_directories(${CMAKE_BINARY_DIR}/src)

set_target_properties(${LIBTHUMBNAILER_QT} PROPERTIES
    VERSION "${LIBTHUMBNAILER_QT_SO_VERSION_MAJOR}.${LIBTHUMBNAILER_QT_SO_VERSION_MINOR}.${LIBTHUMBNAILER_QT_SO_VERSION_MICRO}"
    SOVERSION ${LIBTHUMBNAILER_QT_SO_VERSION}
)

set(symbol_map "${CMAKE_SOURCE_DIR}/src/liblomiri-thumbnailer-qt/liblomiri-thumbnailer-qt.map")
set_target_properties(${LIBTHUMBNAILER_QT} PROPERTIES
                      LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map} ")
set_target_properties(${LIBTHUMBNAILER_QT} PROPERTIES LINK_DEPENDS ${symbol_map})

target_link_libraries(${LIBTHUMBNAILER_QT} thumbnailer-static Qt5::DBus Qt5::Gui)
set_target_properties(${LIBTHUMBNAILER_QT} PROPERTIES AUTOMOC TRUE)
add_dependencies(${LIBTHUMBNAILER_QT} thumbnailer-service)

install(
  TARGETS lomiri-thumbnailer-qt
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

# Set up package config.
configure_file(lib${LIBTHUMBNAILER_QT}.pc.in lib${LIBTHUMBNAILER_QT}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${LIBTHUMBNAILER_QT}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/service/CMakeLists.txt ===
qt5_add_dbus_adaptor(adaptor_files dbusinterface.xml dbusinterface.h lomiri::thumbnailer::service::DBusInterface)
qt5_add_dbus_adaptor(adaptor_files admininterface.xml admininterface.h lomiri::thumbnailer::service::AdminInterface)

set_source_files_properties(bus.xml PROPERTIES
  CLASSNAME BusInterface)
qt5_add_dbus_interface(interface_files bus.xml businterface)

add_executable(thumbnailer-service
  admininterface.cpp
  client_config.cpp
  credentialscache.cpp
  dbusinterface.cpp
  handler.cpp
  inactivityhandler.cpp
  main.cpp
  stats.cpp
  ${adaptor_files}
  ${interface_files}
)
find_package(Qt5Concurrent REQUIRED)
target_link_libraries(thumbnailer-service thumbnailer-static Qt5::DBus Qt5::Concurrent)
set_target_properties(thumbnailer-service PROPERTIES AUTOMOC TRUE)
add_dependencies(thumbnailer-service vs-thumb)

install(
  TARGETS thumbnailer-service
  RUNTIME DESTINATION ${SHARE_PRIV_DIR}
)

# Install the service file.
configure_file(com.lomiri.Thumbnailer.service.in com.lomiri.Thumbnailer.service)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.Thumbnailer.service
  DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
)

=== src/thumbnailer-admin/CMakeLists.txt ===
set(dbusinterface_xml "${CMAKE_SOURCE_DIR}/src/service/dbusinterface.xml")
set_source_files_properties(${dbusinterface_xml} PROPERTIES
    CLASSNAME ThumbnailerInterface
    INCLUDE ${CMAKE_SOURCE_DIR}/include/service/client_config.h)
qt5_add_dbus_interface(interface_files ${dbusinterface_xml} thumbnailerinterface)

set(admininterface_xml "${CMAKE_SOURCE_DIR}/src/service/admininterface.xml")
set_source_files_properties(${admininterface_xml} PROPERTIES
    CLASSNAME AdminInterface
    INCLUDE ${CMAKE_SOURCE_DIR}/src/service/stats.h)
qt5_add_dbus_interface(interface_files ${admininterface_xml} admininterface)

add_executable(lomiri-thumbnailer-admin
    clear.cpp
    dbus_connection.cpp
    get_local_thumbnail.cpp
    get_remote_thumbnail.cpp
    parse_size.cpp
    show_stats.cpp
    shutdown.cpp
    thumbnailer-admin.cpp
    util.cpp
    ${CMAKE_SOURCE_DIR}/src/file_io.cpp
    ${CMAKE_SOURCE_DIR}/src/safe_strerror.cpp
    ${CMAKE_SOURCE_DIR}/src/service/stats.cpp
    ${interface_files}
)
target_link_libraries(lomiri-thumbnailer-admin thumbnailer-static Qt5::DBus ${CACHE_DEPS_LDFLAGS} ${Boost_LIBRARIES})
add_dependencies(lomiri-thumbnailer-admin thumbnailer-service)

INSTALL(TARGETS lomiri-thumbnailer-admin
        RUNTIME
        DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
lomiri-thumbnailer (3.0.5-2) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/patches:
    + Add 0001_tests-Increase-timeouts-in-tests-to-make-tests-more-.patch.
      Increase chance of tests passing in slow archs (such as riscv64).
      Thanks to Aurelien Jarno for providing the patch. (Closes: #1117634).

  [ Helmut Grohne ]
  * debian/control:
    + Add B-D on libglib2.0-dev:native. Fix FTCBFS. (Closes: #1104983).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 10 Oct 2025 14:33:42 +0200

lomiri-thumbnailer (3.0.5-1) unstable; urgency=medium

  * New upstream release.
    - Supporting building with CMake 4. (Closes: #1113249).
  * debian/:
    + Enable build of doc:pkg liblomiri-thumbnailer-qt-doc.
    + Drop usage of pkgkde_symbolshelper.
  * debian/patches:
    + Drop 0004-Fix-taglib-2.x-compatibility.patch. Patch applied upstream.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Update copyright attributions for debian/.
  * debian/rules:
    + Drop setting QT_SELECT variable.
    + Build with -DENABLE_UBUNTU_COMPAT=OFF.
    + Set -DCMAKE_INSTALL_DOCDIR=share/doc/liblomiri-thumbnailer-qt-dev at build
      time.
  * debian/liblomiri-thumbnailer-qt-doc.doc-base:
    + Add file.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 02 Oct 2025 01:38:54 +0200

=== debian/control ===
Source: lomiri-thumbnailer
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Build-Depends: cmake,
               cmake-extras (>= 0.4),
               debhelper-compat (= 13),
               google-mock,
               gstreamer1.0-libav,
               gstreamer1.0-plugins-bad-faad,
               gstreamer1.0-plugins-good,
               libapparmor-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-regex-dev,
               libexif-dev,
               libgdk-pixbuf-2.0-dev,
               libglib2.0-dev:native,
               libgstreamer1.0-dev,
               libgstreamer-plugins-base1.0-dev,
               libgtest-dev,
               libleveldb-dev,
               libqtdbustest1-dev,
               librsvg2-common,
               libtag-dev,
               liblomiri-api-dev,
               licensecheck,
               lsb-release,
               persistent-cache-cpp-dev (>= 1.0.7-1~),
               python3-tornado <!nocheck>,
               qml-module-qtquick2,
               qml-module-qttest,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtdeclarative5-dev,
               shared-mime-info,
               xauth,
               xvfb,
               doxygen,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-thumbnailer
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-thumbnailer/
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-thumbnailer.git

Package: lomiri-thumbnailer-service
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends},
Depends: dconf-cli,
         ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libthumbnailer0, thumbnailer-common
Replaces: libthumbnailer0, thumbnailer-common
Description: D-Bus service for out of process thumbnailing
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 This package provides thumbnailer D-Bus service that can provide
 thumbnails on behalf of another process.

Package: qml-module-lomiri-thumbnailer
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
         liblomiri-thumbnailer-qt1.0 (= ${binary:Version}),
Recommends: lomiri-thumbnailer-service (= ${binary:Version}),
Description: QML interface for the thumbnailer
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 This package provides image providers that allow access to the
 thumbnailer from Qt Quick 2 / QML applications.

Package: liblomiri-thumbnailer-qt1.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-thumbnailer-service,
Description: Qt/C++ API to obtain thumbnails
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 Library providing a client API for obtaining thumbnails from the DBus
 service.

Package: liblomiri-thumbnailer-qt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: liblomiri-thumbnailer-qt1.0 (= ${binary:Version}),
         ${misc:Depends},
Description: Qt/C++ API to obtain thumbnails (development files)
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 Library providing a client API for obtaining thumbnails from the DBus
 service.
 .
 This package provides the development files for the library.

Package: liblomiri-thumbnailer-qt-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: Documentation for Thumbnailer API
 Lomiri Thumbnailer is an API for the Lomiri operating environment to
 create and cache image thumbnails for local and remote media.
 .
 API documentation of Thumbnailer API.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

NULL =

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export DPKG_GENSYMBOLS_CHECK_LEVEL=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# http://ccache.samba.org/manual.html#_precompiled_headers
export CCACHE_SLOPPINESS=time_macros

%:
	dh $@

distro=$(shell lsb_release -c -s)
ifeq ($(distro), focal)
	# GlibC 2.31 in Ubuntu Focal has a bug which tries to use static-TLS area
	# to optimize TLS access in dynamically-loaded libraries, but end up not
	# having enough static-TLS area for the library that need it. See CMakeLists.txt
	# in the root. The issue is fixed in Glibc 2.32, but GlibC 2.31 in Debian seems
	# to be patched, thus this is not needed for Debian.
	ifneq ($(filter arm64 ppc64el, $(DEB_HOST_ARCH)),)
		ARCH_OPT := -DWORKAROUND_LIBGOMP_STATIC_TLS=ON
	endif
endif

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_SYSCONFDIR=/etc \
	                     -DCMAKE_INSTALL_DOCDIR=share/doc/liblomiri-thumbnailer-qt-dev \
	                     -DENABLE_UBUNTU_COMPAT=OFF $(ARCH_OPT) \
	                     $(NULL)

# Tests are not written to be run in parallel.
# We ignore failing tests on PPC because the thumbnailer is irrelevant there,
# and gstreamer has bugs in the plugins for PPC.
test_args = --max-parallel=1 -- ARGS=\"--verbose\"
override_dh_auto_test:
#ifneq (,$(filter powerpc ppc64el s390x,$(DEB_HOST_ARCH)))
#	dh_auto_test $(test_args) || :
#else
	dh_auto_test $(test_args)
#endif

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
